Index: /trunk/src/uvmat.m
===================================================================
--- /trunk/src/uvmat.m	(revision 353)
+++ /trunk/src/uvmat.m	(revision 354)
@@ -1228,167 +1260,169 @@
 run0_Callback(hObject, eventdata, handles)
 
-%------------------------------------------------------------------------
-% --- Update information about a new second field series (indices to scan, timing,
-%     calibration from an xml file, then refresh current plots
-function update_rootinfo_1(hObject,eventdata,handles) %A REVOIR
-% -----------------------------------------------------------------------
-set(handles.RootPath_1,'BackgroundColor',[1 1 0])% indicate active program by yellow color
-drawnow
-UvData=get(handles.uvmat,'UserData');%huvmat=handles of the uvmat interface
-UvData.NewSeries=1; %flag for run0: begin a new series
-
-[FileName,RootPath,FileBase,FileIndices,FileExt,SubDir]=read_file_boxes_1(handles);
-if ~exist(FileName,'file')
-    msgbox_uvmat('ERROR',['input file ' FileName ' not found']);
-end
-set(handles.FixVelType,'Value',0); %desactivate fixed veltype
-nbfield_1=[];%default
-nbfield_j_1=[];%default
-XmlData.Time=[];
-XmlData.GeometryCalib=[];%default
-TimeUnit=[];
-if isfield(UvData,'TimeUnit')
-    TimeUnit=UvData.TimeUnit;
-end
-TimeUnit_1=[];
-hhh='';%default, test for  movie reading with mmreader
-imainfo=[];
-if isequal(lower(FileExt),'.avi') %.avi file
-    imainfo=aviinfo([FileBase FileIndices FileExt]);
-    nbfield_1=imainfo.NumFrames;
-    nbfield_j_1=1;
-    set(handles.Dt_txt,'String',['Dt=' num2str(1000/info.FramesPerSecond) 'ms']);%display the elementary time interval in millisec
-    time=(0:1/imainfo.FramesPerSecond:(imainfo.NumFrames-1)/imainfo.FramesPerSecond)';
-    ColorType=imainfo.ImageType;%='truecolor' for color images
-    hhh=which('mmreader');
-elseif ~isempty(imformats(FileExt(2:end)))|| isequal(FileExt,'.vol')
-    if ~isequal(SubDir,'')
-        RootFile=get(handles.RootFile,'String');
-        imainfo=imfinfo([fullfile(RootPath,SubDir,RootFile) FileIndices FileExt]);
-    else
-        imainfo=imfinfo([FileBase FileIndices FileExt]);
-    end
-    ColorType=imainfo.ColorType;%='truecolor' for color images
-    if length(imainfo) >1 %case of image with multiple frames
-        nbfield_1=length(imainfo);
-        nbfield_j_1=1;
-    end 
-end
-if ~strcmp(hhh,'')&& mmreader.isPlatformSupported()% if the function is found (recent version of matlab)
-    UvData.MovieObject_1=mmreader([FileBase FileIndices FileExt]);
-elseif isfield(UvData,'MovieObject_1')
-    UvData=rmfield(UvData,'MovieObject_1');
-end
-if ~isempty(imainfo)% (an image has been introduced as second fierld input)
-    if strcmp(get(handles.num_Npx,'String'),'') || strcmp(get(handles.num_Npy,'String'),'')%update npx and npy if it is not already filled by the first input field
-        if  isfield(imainfo,'Width') && isfield(imainfo,'Height')
-            set(handles.num_Npx,'String',num2str(imainfo.Width));%fills nbre of pixels x box
-            set(handles.num_Npy,'String',num2str(imainfo.Height));%fills nbre of pixels x box
-        else
-            set(handles.num_Npx,'String','');%fills nbre of pixels x box
-            set(handles.num_Npy,'String','');%fills nbre of pixels x box
-        end
-        set(handles.CheckBW,'Value',strcmp(ColorType,'grayscale'))% select handles.CheckBW if grayscale image
-    end
-end
-% find scaling parameters
-filexml=[FileBase '.xml'];
-fileciv=[FileBase '.civ'];
-warntext='';%default warning text
-if exist(filexml,'file')
-    [XmlData,warntext]=imadoc2struct(filexml);
-    if ~isempty(warntext)
-        msgbox_uvmat('WARNING',warntext)
-    end
-    if isfield(XmlData,'Camera')
-        if isfield(XmlData.Camera,'TimeUnit')&& ~isempty(XmlData.Camera.TimeUnit)
-            TimeUnit=XmlData.Camera.TimeUnit;
-        end
-    end 
-elseif exist(fileciv,'file')% if .civ file found 
-    [error,XmlData.Time,TimeUnit,mode,npx,npy,pxcmx,pxcmy]=read_imatext([FileBase '.civ']);
-    GeometryCalib.R=[pxcmx 0 0; 0 pxcmy 0;0 0 0];
-    GeometryCalib.Tx=0;
-    GeometryCalib.Ty=0;
-    GeometryCalib.Tz=1;
-    GeometryCalib.dpx=1;
-    GeometryCalib.dpy=1;
-    GeometryCalib.sx=1;
-    GeometryCalib.Cx=0;
-    GeometryCalib.Cy=0;
-    GeometryCalib.f=1;
-    GeometryCalib.kappa1=0;
-    GeometryCalib.CoordUnit='cm';
-    XmlData.GeometryCalib=GeometryCalib;
-    if error==2, warntext=['no file ' FileBase '.civ'];
-    elseif error==1, warntext='inconsistent number of fields in the .civ file';
-    end
-    
-    set(handles.num_Npx,'String',num2str(npx));%fills nbre of pixels x box
-    set(handles.num_Npy,'String',num2str(npy));%fills nbre of pixels y box
-    set(handles.pxcm,'String',num2str(pxcmx));%fills scale x (pixel/cm) box
-    set(handles.pycm,'String',num2str(pxcmy));%fills scale y (pixel/cm) box
-    set(handles.pxcm,'Visible','on');%fills scale x (pixel/cm) box 
-    set(handles.pycm,'Visible','on');%fills scale y (pixel/cm) box 
-end   
-if ~isempty(TimeUnit_1) && ~isequal(TimeUnit_1,TimeUnit)
-        msgbox_uvmat('WARNING','the time units for the second series differs from the first one')
-end
-        
-% store last index in handles.lat_i and .last_j
-if ~isempty(XmlData.Time)
-    nbfield_1=size(XmlData.Time,1);
-    nbfield_j_1=size(XmlData.Time,2);   
-end
-last_i_cell=get(handles.last_i,'String');
-if isempty(nbfield_1)
-    last_i_cell{2}='';
-else
-    last_i_cell{2}=num2str(nbfield_1);
-end
-set(handles.last_i,'String',last_i_cell)
-last_j_cell=get(handles.last_j,'String');
-if isempty(nbfield_j_1)
-     last_j_cell{2}='';
-else
-     last_j_cell{2}=num2str(nbfield_j_1);
-end
-set(handles.last_j,'String',last_j_cell);
-if ~isequal(last_i_cell{1},last_i_cell{2}) || ~isequal(last_j_cell{1},last_j_cell{2})
-        msgbox_uvmat('WARNING','the numbers of input file of the second series differs from the first one')
-end
-
-% store calibration data
-GeometryCalib=XmlData.GeometryCalib;
-if isempty(GeometryCalib)
-    if isfield(UvData, 'GeometryCalib_1')
-        UvData=rmfield(UvData,'GeometryCalib_1');
-    end
-else
-    UvData.GeometryCalib_1=GeometryCalib;
-    if (isfield(GeometryCalib,'R')&& ~isequal(GeometryCalib.R(2,1),0) && ~isequal(GeometryCalib.R(1,2),0)) ||...
-        (isfield(GeometryCalib,'kappa1')&& ~isequal(GeometryCalib.kappa1,0))
-        set(handles.pxcm,'String','var')
-        set(handles.pycm,'String','var')
-    else
-        if isfield(GeometryCalib,'fx_fy')
-            pixcmx=GeometryCalib.fx_fy(1);
-            pixcmy=GeometryCalib.fx_fy(2);
-            set(handles.pxcm,'String',num2str(pixcmx))
-            set(handles.pycm,'String',num2str(pixcmy))
-        end
-    end
-end
-UvData.XmlData_1=XmlData;
-set(handles.uvmat,'UserData',UvData)%update the data attached to the uvmat interface
-
-if ~isequal(warntext,'')
-    msgbox_uvmat('WARNING',warntext)
-end
-
-set(handles.RootPath_1,'BackgroundColor',[1 1 1])% signa the end the input operation
-drawnow
-
-set_scan_options(handles)
+% %------------------------------------------------------------------------
+% % --- Update information about a new second field series (indices to scan, timing,
+% %     calibration from an xml file, then refresh current plots
+% function update_rootinfo_1(handles,i1_series,i2_series,j1_series,j2_series,FileType,MovieObject) %A REVOIR
+% % -----------------------------------------------------------------------
+% set(handles.RootPath_1,'BackgroundColor',[1 1 0])% indicate active program by yellow color
+% drawnow
+% UvData=get(handles.uvmat,'UserData');%huvmat=handles of the uvmat interface
+% UvData.NewSeries=1; %flag for run0: begin a new series
+% [RootPath,SubDir,RootFile,FileIndices,FileExt]=read_file_boxes_1(handles);
+% FileName=[fullfile(RootPath,SubDir,RootFile) FileIndices FileExt];
+% %[FileName,RootPath,FileBase,FileIndices,FileExt,SubDir]=read_file_boxes_1(handles);
+% if ~exist(FileName,'file')
+%     msgbox_uvmat('ERROR',['input file ' FileName ' not found']);
+% end
+% set(handles.FixVelType,'Value',0); %desactivate fixed veltype
+% nbfield_1=[];%default
+% nbfield_j_1=[];%default
+% XmlData.Time=[];
+% XmlData.GeometryCalib=[];%default
+% TimeUnit=[];
+% if isfield(UvData,'TimeUnit')
+%     TimeUnit=UvData.TimeUnit;
+% end
+% TimeUnit_1=[];
+% hhh='';%default, test for  movie reading with mmreader
+% imainfo=[];
+% FileBase=fullfile(RootPath,RootFile);
+% if isequal(lower(FileExt),'.avi') %.avi file
+%     imainfo=aviinfo([FileBase FileIndices FileExt]);
+%     nbfield_1=imainfo.NumFrames;
+%     nbfield_j_1=1;
+%     set(handles.Dt_txt,'String',['Dt=' num2str(1000/info.FramesPerSecond) 'ms']);%display the elementary time interval in millisec
+%     time=(0:1/imainfo.FramesPerSecond:(imainfo.NumFrames-1)/imainfo.FramesPerSecond)';
+%     ColorType=imainfo.ImageType;%='truecolor' for color images
+%     hhh=which('mmreader');
+% elseif ~isempty(imformats(FileExt(2:end)))|| isequal(FileExt,'.vol')
+%     if ~isequal(SubDir,'')
+%         RootFile=get(handles.RootFile,'String');
+%         imainfo=imfinfo([fullfile(RootPath,SubDir,RootFile) FileIndices FileExt]);
+%     else
+%         imainfo=imfinfo([FileBase FileIndices FileExt]);
+%     end
+%     ColorType=imainfo.ColorType;%='truecolor' for color images
+%     if length(imainfo) >1 %case of image with multiple frames
+%         nbfield_1=length(imainfo);
+%         nbfield_j_1=1;
+%     end 
+% end
+% if ~strcmp(hhh,'')&& mmreader.isPlatformSupported()% if the function is found (recent version of matlab)
+%     UvData.MovieObject_1=mmreader([FileBase FileIndices FileExt]);
+% elseif isfield(UvData,'MovieObject_1')
+%     UvData=rmfield(UvData,'MovieObject_1');
+% end
+% if ~isempty(imainfo)% (an image has been introduced as second fierld input)
+%     if strcmp(get(handles.num_Npx,'String'),'') || strcmp(get(handles.num_Npy,'String'),'')%update npx and npy if it is not already filled by the first input field
+%         if  isfield(imainfo,'Width') && isfield(imainfo,'Height')
+%             set(handles.num_Npx,'String',num2str(imainfo.Width));%fills nbre of pixels x box
+%             set(handles.num_Npy,'String',num2str(imainfo.Height));%fills nbre of pixels x box
+%         else
+%             set(handles.num_Npx,'String','');%fills nbre of pixels x box
+%             set(handles.num_Npy,'String','');%fills nbre of pixels x box
+%         end
+%         set(handles.CheckBW,'Value',strcmp(ColorType,'grayscale'))% select handles.CheckBW if grayscale image
+%     end
+% end
+% % find scaling parameters
+% filexml=[FileBase '.xml'];
+% fileciv=[FileBase '.civ'];
+% warntext='';%default warning text
+% if exist(filexml,'file')
+%     [XmlData,warntext]=imadoc2struct(filexml);
+%     if ~isempty(warntext)
+%         msgbox_uvmat('WARNING',warntext)
+%     end
+%     if isfield(XmlData,'Camera')
+%         if isfield(XmlData.Camera,'TimeUnit')&& ~isempty(XmlData.Camera.TimeUnit)
+%             TimeUnit=XmlData.Camera.TimeUnit;
+%         end
+%     end 
+% elseif exist(fileciv,'file')% if .civ file found 
+%     [error,XmlData.Time,TimeUnit,mode,npx,npy,pxcmx,pxcmy]=read_imatext([FileBase '.civ']);
+%     GeometryCalib.R=[pxcmx 0 0; 0 pxcmy 0;0 0 0];
+%     GeometryCalib.Tx=0;
+%     GeometryCalib.Ty=0;
+%     GeometryCalib.Tz=1;
+%     GeometryCalib.dpx=1;
+%     GeometryCalib.dpy=1;
+%     GeometryCalib.sx=1;
+%     GeometryCalib.Cx=0;
+%     GeometryCalib.Cy=0;
+%     GeometryCalib.f=1;
+%     GeometryCalib.kappa1=0;
+%     GeometryCalib.CoordUnit='cm';
+%     XmlData.GeometryCalib=GeometryCalib;
+%     if error==2, warntext=['no file ' FileBase '.civ'];
+%     elseif error==1, warntext='inconsistent number of fields in the .civ file';
+%     end
+%     
+%     set(handles.num_Npx,'String',num2str(npx));%fills nbre of pixels x box
+%     set(handles.num_Npy,'String',num2str(npy));%fills nbre of pixels y box
+%     set(handles.pxcm,'String',num2str(pxcmx));%fills scale x (pixel/cm) box
+%     set(handles.pycm,'String',num2str(pxcmy));%fills scale y (pixel/cm) box
+%     set(handles.pxcm,'Visible','on');%fills scale x (pixel/cm) box 
+%     set(handles.pycm,'Visible','on');%fills scale y (pixel/cm) box 
+% end   
+% if ~isempty(TimeUnit_1) && ~isequal(TimeUnit_1,TimeUnit)
+%         msgbox_uvmat('WARNING','the time units for the second series differs from the first one')
+% end
+%         
+% % store last index in handles.lat_i and .last_j
+% if ~isempty(XmlData.Time)
+%     nbfield_1=size(XmlData.Time,1);
+%     nbfield_j_1=size(XmlData.Time,2);   
+% end
+% last_i_cell=get(handles.last_i,'String');
+% if isempty(nbfield_1)
+%     last_i_cell{2}='';
+% else
+%     last_i_cell{2}=num2str(nbfield_1);
+% end
+% set(handles.last_i,'String',last_i_cell)
+% last_j_cell=get(handles.last_j,'String');
+% if isempty(nbfield_j_1)
+%      last_j_cell{2}='';
+% else
+%      last_j_cell{2}=num2str(nbfield_j_1);
+% end
+% set(handles.last_j,'String',last_j_cell);
+% if ~isequal(last_i_cell{1},last_i_cell{2}) || ~isequal(last_j_cell{1},last_j_cell{2})
+%         msgbox_uvmat('WARNING','the numbers of input file of the second series differs from the first one')
+% end
+% 
+% % store calibration data
+% GeometryCalib=XmlData.GeometryCalib;
+% if isempty(GeometryCalib)
+%     if isfield(UvData, 'GeometryCalib_1')
+%         UvData=rmfield(UvData,'GeometryCalib_1');
+%     end
+% else
+%     UvData.GeometryCalib_1=GeometryCalib;
+%     if (isfield(GeometryCalib,'R')&& ~isequal(GeometryCalib.R(2,1),0) && ~isequal(GeometryCalib.R(1,2),0)) ||...
+%         (isfield(GeometryCalib,'kappa1')&& ~isequal(GeometryCalib.kappa1,0))
+%         set(handles.pxcm,'String','var')
+%         set(handles.pycm,'String','var')
+%     else
+%         if isfield(GeometryCalib,'fx_fy')
+%             pixcmx=GeometryCalib.fx_fy(1);
+%             pixcmy=GeometryCalib.fx_fy(2);
+%             set(handles.pxcm,'String',num2str(pixcmx))
+%             set(handles.pycm,'String',num2str(pixcmy))
+%         end
+%     end
+% end
+% UvData.XmlData_1=XmlData;
+% set(handles.uvmat,'UserData',UvData)%update the data attached to the uvmat interface
+% 
+% if ~isequal(warntext,'')
+%     msgbox_uvmat('WARNING',warntext)
+% end
+% 
+% set(handles.RootPath_1,'BackgroundColor',[1 1 1])% signa the end the input operation
+% drawnow
+% 
+% set_scan_options(handles)
 
 %------------------------------------------------------------------------
@@ -1435,17 +1469,16 @@
 set(handles.i1,'BackgroundColor',[0.7 0.7 0.7])
 NomType=get(handles.NomType,'String');
-% NomType=get(handles.FileIndex,'UserData');
-num1=stra2num(get(handles.i1,'String'));
-num2=stra2num(get(handles.i2,'String'));
-num_a=stra2num(get(handles.j1,'String'));
-num_b=stra2num(get(handles.j2,'String'));
-indices=name_generator('',num1,num_a,'',NomType,1,num2,num_b,'');
+i1=stra2num(get(handles.i1,'String'));
+i2=stra2num(get(handles.i2,'String'));
+j1=stra2num(get(handles.j1,'String'));
+j2=stra2num(get(handles.j2,'String'));
+indices=fullfile_uvmat('','','','',NomType,i1,i2,j1,j2);
+%indices=name_generator('',num1,num_a,'',NomType,1,num2,num_b,'');
 set(handles.FileIndex,'String',indices)
 set(handles.FileIndex,'BackgroundColor',[0.7 0.7 0.7])
 if get(handles.SubField,'Value')==1
     NomType_1=get(handles.NomType_1,'String');
-%      FileExt_1=get(handles.FileExt_1,'String');
-%     [P,F,str1,str2,str_a,str_b,Ext,NomType_1]=name2display(['xx' NomType_1 FileExt_1]);
-     indices=name_generator('',num1,num_a,'',NomType_1,1,num2,num_b,'');
+    indices=fullfile_uvmat('','','','',NomType,i1,i2,j1,j2);
+     %indices=name_generator('',num1,num_a,'',NomType_1,1,num2,num_b,'');
      set(handles.FileIndex_1,'String',indices)
      set(handles.FileIndex_1,'BackgroundColor',[0.7 0.7 0.7])
@@ -1512,5 +1545,7 @@
 function view_xml_Callback(hObject, eventdata, handles)
 %------------------------------------------------------------------------
-[FileName,RootPath,FileBase,FileIndices,FileExt]=read_file_boxes(handles);
+%[FileName,RootPath,FileBase,FileIndices,FileExt]=read_file_boxes(handles);
+ [RootPath,SubDir,RootFile,FileIndices,FileExt]=read_file_boxes(handles);
+FileBase=fullfile(RootPath,RootFile);
 option=get(handles.view_xml,'String');
 if isequal(option,'view .xml')
@@ -1525,5 +1560,7 @@
 %case of view mask selection
 if isequal(get(handles.CheckMask,'Value'),1)
-    [FF,RootPath,FileBase]=read_file_boxes(handles);
+   % [FF,RootPath,FileBase]=read_file_boxes(handles);
+     [RootPath,SubDir,RootFile,FileIndices,FileExt]=read_file_boxes(handles);
+     FileBase=fullfile(RootPath,RootFile);
     num_i1=stra2num(get(handles.i1,'String'));
     num_j1=stra2num(get(handles.j1,'String'));
@@ -1562,5 +1599,7 @@
             num_i1=mod(num_i1-1,nbslice)+1;
             Mask.NomType=regexprep(Mask_NomType{1},'0','');%remove '0' in nom type for masks
-            maskname=name_generator(Mask.Base,num_i1,num_j1,'.png',Mask.NomType);%
+            [RootPath,RootFile]=fileparts(Mask.Base);
+            maskname=fullfile_uvmat(RootPath,'',RootFile,'.png',Mask.NomType,num_i1,[],num_j1);
+            %maskname=name_generator(Mask.Base,num_i1,num_j1,'.png',Mask.NomType);%
             mdetect=exist(maskname,'file');
             if mdetect
@@ -1624,5 +1663,7 @@
 end
 num_i1_mask=mod(num_i1-1,MaskData.NbSlice)+1;
-MaskName=name_generator(MaskData.Base,num_i1_mask,num_j1,'.png',MaskData.NomType);
+[RootPath,RootFile]=fileparts(MaskData.Base);
+MaskName=fullfile_uvmat(RootPath,'',RootFile,'.png',MaskData.NomType,num_i1_mask,[],num_j1);
+%MaskName=name_generator(MaskData.Base,num_i1_mask,num_j1,'.png',MaskData.NomType);
 huvmat=get(handles.CheckMask,'parent');
 UvData=get(huvmat,'UserData');
@@ -1840,9 +1881,9 @@
 InputFile.RootFile=regexprep(InputFile.RootFile,'^[\\/]|[\\/]$','');%suppress possible / or \ separator at the beginning or the end of the string
 InputFile.SubDir=regexprep(InputFile.SubDir,'^[\\/]|[\\/]$','');%suppress possible / or \ separator at the beginning or the end of the string
-if isempty(InputFile.RootFile)
-    filebase=InputFile.RootPath;
-else
-    filebase=fullfile(InputFile.RootPath,InputFile.RootFile);
-end
+% if isempty(InputFile.RootFile)
+%     filebase=InputFile.RootPath;
+% else
+ filebase=fullfile(InputFile.RootPath,InputFile.RootFile);
+% end
 FileExt=InputFile.FileExt;
 % [FileName,RootPath,filebase,FileIndices,FileExt,subdir]=read_file_boxes(handles);
@@ -1855,4 +1896,5 @@
 sub_value= get(handles.SubField,'Value');
 if sub_value % a second input file has been entered
+    
     [FileName_1,RootPath_1,filebase_1,FileIndices_1,FileExt_1,SubDir_1]=read_file_boxes_1(handles);
     [tild,tild,tild,i1_1,i2_1,j1_1,j2_1]=fileparts_uvmat(FileIndices_1);
@@ -1873,7 +1915,15 @@
     i1=i1+increment;
     i2=i2+increment;
+    if sub_value
+        i1_1=i1_1+increment;
+        i2_1=i2_1+increment;
+    end
 else % case of scanning along index j (burst numbers)
     j1=j1+increment;
     j2=j2+increment;
+    if sub_value
+        j1_1=j1_1+increment;
+        j2_1=j2_1+increment;
+    end
 end
 if ~comp_input
@@ -1890,29 +1940,26 @@
         end
     end
-    if ref_i+1>size(UvData.i1_series,1)
+    if ref_i+1>size(UvData.i1_series{1},1)
         msgbox_uvmat('ERROR','maximum i index exceeded');
         return
     end
-    if ref_j+1>size(UvData.i1_series,2)
+    if ref_j+1>size(UvData.i1_series{1},2)
         msgbox_uvmat('ERROR','maximum j index exceeded');
         return
     end
-    i1=UvData.i1_series(ref_i+1,ref_j+1,1);
-    if ~isempty(UvData.i2_series)
-        i2=UvData.i2_series(ref_i+1,ref_j+1,1);
-    end
-    if ~isempty(UvData.j1_series)
-        j1=UvData.j1_series(ref_i+1,ref_j+1,1);
-    end
-    if ~isempty(UvData.j2_series)
-        j2=UvData.j2_series(ref_i+1,ref_j+1,1);
+    i1=UvData.i1_series{1}(ref_i+1,ref_j+1,1);
+    if ~isempty(UvData.i2_series{1})
+        i2=UvData.i2_series{1}(ref_i+1,ref_j+1,1);
+    end
+    if ~isempty(UvData.j1_series{1})
+        j1=UvData.j1_series{1}(ref_i+1,ref_j+1,1);
+    end
+    if ~isempty(UvData.j2_series{1})
+        j2=UvData.j2_series{1}(ref_i+1,ref_j+1,1);
     end
 end
 filename=fullfile_uvmat(InputFile.RootPath,InputFile.SubDir,InputFile.RootFile,FileExt,NomType,i1,i2,j1,j2);
-% filename=name_generator(filebase,i1,j1,FileExt,NomType,comp_input,i2,j2,InputFile.SubDir);
 if sub_value
-    j1_1=j1_1+increment;
-    j2_1=j2_1+increment;
-    filename_1=name_generator(filebase_1,i1_1,j1_1,FileExt_1,NomType_1,1,i2_1,j2_1,SubDir_1);
+    filename_1=fullfile_uvmat(InputFile.RootPath_1,InputFile.SubDir_1,InputFile.RootFile_1,FileExt_1,NomType_1,i1_1,i2_1,j1_1,j2_1);
 end
 
@@ -1938,5 +1985,6 @@
     set(handles.FileIndex,'String',indices);
     if ~isempty(filename_1)
-        indices_1=name_generator('',i1_1,j1_1,'',NomType_1,1,i2_1,j2_1,'');
+        indices_1=fullfile_uvmat('','','','',NomType_1,i1_1,i2_1,j1_1,j2_1);
+        %indices_1=name_generator('',i1_1,j1_1,'',NomType_1,1,i2_1,j2_1,'');
         set(handles.FileIndex_1,'String',indices_1);
     end
@@ -1951,5 +1999,4 @@
 function movie_pair_Callback(hObject, eventdata, handles)
 %------------------------------------------------------------------------
-
 %% stop movie action if the movie_pair button is off
 if ~get(handles.movie_pair,'value')
@@ -1971,5 +2018,5 @@
 if isequal(FieldName,'image')
     test_1=0;
-    [ff,rr,filebase,xx,Ext,SubDir]=read_file_boxes(handles);
+    [RootPath,SubDir,RootFile,FileIndices,Ext]=read_file_boxes(handles);
     NomType=get(handles.NomType,'String');
 else
@@ -1979,22 +2026,21 @@
     if isequal(FieldName,'image')
         test_1=1;
-        [ff,rr,filebase,xx,Ext,SubDir]=read_file_boxes_1(handles);
-        NomType=get(handles.NomType_1,'String');
-%         NomType=get(handles.FileIndex_1,'UserData');
+        [RootPath,tild,RootFile,FileIndex_1,Ext,NomType]=read_file_boxes_1(handles);
     else
         msgbox_uvmat('ERROR','an image or movie must be first introduced as input')
         set(handles.movie_pair,'BackgroundColor',[1 0 0])%paint the command button in red
+        set(handles.movie_pair,'Value',0)
         return
     end
 end
-
-num_i1=str2double(get(handles.i1,'String'));
+num_i1=str2num(get(handles.i1,'String'));
 num_j1=stra2num(get(handles.j1,'String'));
-num_i2=str2double(get(handles.i2,'String'));
+num_i2=str2num(get(handles.i2,'String'));
 num_j2=stra2num(get(handles.j2,'String'));
-if isnan(num_j2)
+if isempty(num_j2)
     if isempty(num_i2)   
         msgbox_uvmat('ERROR', 'a second image index i2 or j2 is needed to show the pair as a movie')
         set(handles.movie_pair,'BackgroundColor',[1 0 0])%paint the command button in red
+         set(handles.movie_pair,'Value',0)
         return
     else
@@ -2002,11 +2048,13 @@
     end
 end
-if isnan(num_i2)
+if isempty(num_i2)
     num_i2=num_i1;%repeat the index i1 by default
 end
-imaname_1=name_generator(filebase,num_i2,num_j2,Ext,NomType);
+% imaname_1=name_generator(filebase,num_i2,num_j2,Ext,NomType);
+imaname_1=fullfile_uvmat(RootPath,'',RootFile,Ext,NomType,num_i2,[],num_j2);
 if ~exist(imaname_1,'file')
       msgbox_uvmat('ERROR',['second input open (-)  ' imaname_1 ' not found']);
       set(handles.movie_pair,'BackgroundColor',[1 0 0])%paint the command button in red
+       set(handles.movie_pair,'Value',0)
       return
 end
@@ -2029,5 +2077,5 @@
 
 %% determine the input file type
-if (test_1 && isfield(UvData,'MovieObject_1'))||(~test_1 && ~isempty(UvData.MovieObject))
+if (test_1 && isfield(UvData,'MovieObject')&& numel(UvData.MovieObject>=2))||(~test_1 && ~isempty(UvData.MovieObject{1}))
     FileType='movie';
 elseif isequal(lower(Ext),'.avi')
@@ -2048,7 +2096,7 @@
         case 'movie'
             if test_1
-                Field_b.A=read(UvData.MovieObject_1,num_i2);
+                Field_b.A=read(UvData.MovieObject{2},num_i2);
             else
-                Field_b.A=read(UvData.MovieObject,num_i2);
+                Field_b.A=read(UvData.MovieObject{1},num_i2);
             end
         case 'avi'
@@ -2094,4 +2142,5 @@
 end
 set(handles.movie_pair,'BackgroundColor',[1 0 0])%paint the command button in red
+ set(handles.movie_pair,'Value',0)
 
 %------------------------------------------------------------------------
@@ -2101,9 +2150,12 @@
 set(handles.run0,'BackgroundColor',[1 1 0])%paint the command button in yellow
 drawnow
-filename=read_file_boxes(handles);
-
+%filename=read_file_boxes(handles);
+[RootPath,SubDir,RootFile,FileIndices,FileExt]=read_file_boxes(handles);
+filename=[fullfile(RootPath,SubDir,RootFile) FileIndices FileExt];
 filename_1=[];%default
 if get(handles.SubField,'Value')
-    filename_1=read_file_boxes_1(handles);
+    [RootPath_1,SubDir_1,RootFile_1,FileIndices_1,FileExt_1]=read_file_boxes_1(handles);
+    filename_1=[fullfile(RootPath_1,SubDir_1,RootFile_1) FileIndices_1 FileExt_1];
+   % filename_1=read_file_boxes_1(handles);
 end
 num_i1=stra2num(get(handles.i1,'String'));
@@ -2180,6 +2232,6 @@
     FieldName=[];%default
     VelType=[];%default
-    Ext=get(handles.FileExt,'String');
-    FileType=UvData.FileType;
+    FileExt=get(handles.FileExt,'String');
+    FileType=UvData.FileType{1};
     switch FileType
         %     if strcmp(Ext,'.nc')||strcmp(Ext,'.cdf')
@@ -2204,6 +2256,5 @@
             end
         case 'video'
-            ObjectName=UvData.MovieObject;
-            
+            ObjectName=UvData.MovieObject{1};         
         case 'vol' %TODO: update
             if isfield(UvData.XmlData,'Npy') && isfield(UvData.XmlData,'Npx')
@@ -2243,62 +2294,17 @@
         errormsg=['second file ' filename_1 ' does not exist'];
         return
-    else
-        Name=filename_1;
-        FieldName_1=[];%default
-        VelType_1=[];%default
-        if strcmp(get(handles.FileExt_1,'Visible'),'on')
-            Ext_1=get(handles.FileExt_1,'String');
-        else
-            Ext_1=get(handles.FileExt,'String');%read the file extension for the first series (case of veltype comparison within a single file)
-        end
-        NomType_1=get(handles.NomType_1,'String');
-%         NomType_1=get(handles.FileIndex_1,'UserData');
-        if isequal(Ext_1,'.nc')||isequal(Ext_1,'.cdf')
-            FileType_1='netcdf';
-        elseif isfield(UvData,'MovieObject_1')
-            Name=UvData.MovieObject_1;
-            FileType_1='movie';
-        elseif isequal(lower(Ext_1),'.avi')
-            FileType_1='avi';
-        elseif isequal(lower(Ext_1),'.vol')
-            FileType_1='vol';
-            if isfield(UvData.XmlData_1,'Npy') && isfield(UvData.XmlData_1,'Npx')
-                ParamIn.Npy=UvData.XmlData_1.Npy;
-                ParamIn.Npx=UvData.XmlData_1.Npx;
-            else
-                errormsg='Npx and Npy need to be defined in the xml file for volume images .vol';
-                return
-            end
-        else 
-           if length(Ext_1)>=2
-           form=imformats(Ext_1(2:end));
-           if ~isempty(form)% if the extension corresponds to an image format recognized by Matlab
-               if isequal(NomType_1,'*');
-                   FileType_1='multimage';
-               else
-                   FileType_1='image';
-               end
-           end
-           end
-        end
-        if strcmp(FileType_1,'netcdf')
+    end
+    Name=filename_1;
+    FileType_1=UvData.FileType{2};
+    switch FileType_1
+        %     if strcmp(Ext,'.nc')||strcmp(Ext,'.cdf')
+        case {'civx','civdata','netcdf'};
             list_fields=get(handles.Fields_1,'String');% list menu fields
             index_fields=get(handles.Fields_1,'Value');% selected string index
             FieldName_1= list_fields{index_fields}; % selected field
-            if ~isequal(FieldName_1,'get_field...')% read the field names on the interface get_field...
-                VelType_1='';
-                if get(handles.FixVelType,'Value')
-                    VelTypeList=get(handles.VelType_1,'String');
-                    index=get(handles.VelType_1,'Value');
-                    VelType_1=VelTypeList{index};
-                end
-            end
-            if strcmp(VelType_1,'*')% free veltype choice
-                VelType_1=[];
-            elseif strcmp(VelType_1,'"')% veltype the same as for the first field
-                if isempty(VelType)
-                    VelType_1=[];
-                else
-                    VelType_1=VelType;
+            if ~strcmp(FieldName,'get_field...')
+                TestVelType=get(handles.FixVelType,'Value');
+                if TestVelType
+                    VelType_1=setfield(handles);% read the velocity type.
                 end
             end
